package multinomad.tools.cec2013;

import multinomad.config.Configuration;
import multinomad.config.LoadProperties;

public class BasinsF7 extends Basins {
	
	// We approximate the coordinates of every basin with a square 
	// Every basin is limited therefore using 2 coordinates: 
	// The lower (lx0,lx1) and the upper (ux0,ux1) corners of the square  
	private static final double[][] BASINS = {
			{0.25,0.25,0.45,0.45}, 					// 1st basin
			{0.5,0.25,0.8,0.45}, 					// 2
			{0.9,0.25,1.5,0.45}, 					// 3
			{1.6,0.25,2.8,0.45}, 					// 4
			{3,0.25,5.5,0.45}, 					// 5
			{5.6,0.25,9.8,0.45}, 					// 6
			
			{0.25,0.5,0.45,0.8}, 					// 7
			{0.5,0.5,0.8,0.8}, 					// 8
			{0.9,0.5,1.5,0.8}, 					// 9
			{1.6,0.5,2.8,0.8}, 					// 10
			{3,0.5,5.5,0.8}, 					// 11
			{5.6,0.5,9.8,0.8}, 					// 12
			
			{0.25,0.9,0.45,1.5}, 					// 13
			{0.5,0.9,0.8,1.5}, 					// 14
			{0.9,0.9,1.5,1.5}, 					// 15
			{1.6,0.9,2.8,1.5}, 					// 16
			{3,0.9,5.5,1.5}, 					// 17
			{5.6,0.9,9.8,1.5}, 					// 18
			
			{0.25,1.6,0.45,2.8}, 					// 19
			{0.5,1.6,0.8,2.8}, 					// 20
			{0.9,1.6,1.5,2.8}, 					// 21
			{1.6,1.6,2.8,2.8}, 					// 22
			{3,1.6,5.5,2.8}, 					// 23
			{5.6,1.6,9.8,2.8}, 					// 24
			
			{0.25,3,0.45,5.5}, 					// 25
			{0.5,3,0.8,5.5}, 					// 26
			{0.9,3,1.5,5.5}, 					// 27
			{1.6,3,2.8,5.5}, 					// 28
			{3,3,5.5,5.5}, 					// 29
			{5.6,3,9.8,5.5}, 					// 30
			
			{0.25,5.6,0.45,9.8}, 					// 31
			{0.5,5.6,0.8,9.8}, 					// 32
			{0.9,5.6,1.5,9.8}, 					// 33
			{1.6,5.6,2.8,9.8}, 					// 34
			{3,5.6,5.5,9.8}, 					// 35
			{5.6,5.6,9.8,9.8}, 					// 36
			};
	
	
	
	public BasinsF7() {
		super(BASINS);
	}

	@Override
	public double upperNumberOfSamplesBound(double probability) {
		// TODO Auto-generated method stub
		return 0;
	}



	@Override
	public double lowerNumberOfSamplesBound(double probability) {
		// TODO Auto-generated method stub
		return 0;
	}
	
	public static void main(String[] args) {
//		for(int i=0;i<BasinsF6.BASINS.length;i++) {
//			System.out.println(BASINS[i][0]+" "+BASINS[i][1]);
//			System.out.println(BASINS[i][2]+" "+BASINS[i][3]);
//		}
		LoadProperties lp = new LoadProperties(args,null);
		Configuration.setConfiguration(lp);

		BasinsF7 basin = new BasinsF7();
		
		for(int i=0;i<20000;i++) {
			double upperprobability = basin.upperProbability(i);
			double lowerprobability = basin.lowerProbability(i);
			System.out.println(i+" "+lowerprobability+" "+upperprobability);
		}
		
	}



	

}
